#!/usr/bin/perl
#######################################################
#                                                     #
#  Kapcsolsi s statisztikai adatkiemel s          #
#  megjelent program, mely rsze az                 #
#   ***    GPRS Easy Connect programnak         ***   #
# A programot Simon Pter (Perl Tk) s Pintr Gbor   #
# (kapcsoldsi szkriptek) ksztette.                #
# simonpeter@freemail.hu, pint3r@mailbox.hu           #
# (felttlenl olvasd el a LICENSE llomnyt)         #
#                                                     #
# Connection program, part of the GPRS Easy Connect   #
# software made by Peter Simon and Gabor Pinter.      #
#                                                     #
#######################################################


use Tk;
use Socket;
use Tk::Balloon;

#felbonts megllaptsa
$xvidtune=`xvidtune -show`;
$xvidtune=~s /(\"\d+)x(\d+\")/$1.$2/e;
$xvhor=$1;
$xvver=$2;
$xvhor=~ tr /\"//d;
$xvver=~ tr /\"//d;;

$ver="V1.2.2";
$fullong=1413;

#$hav_fenn=1;
#$het_fenn=1;

# minden ltrehozott file rhat-olvashat, de nem futtathat
umask 0111;

# config olvassa
open (FILE, "</usr/share/gprsec/log/EasyConn.config");
$sor=<FILE>;
close FILE;
@spl=split /\:/, $sor;
$co_pan=$spl[2];
$brow=$spl[3];
$brow_on=$spl[4];
read_conf ();
# nyelvi adatok beolvassa
nyelvbeolv ();

# nincs jogosultsg a pppd-hez (ekkor nem jn ltre a conn.log)
sleep 1;
if (!-e "/usr/share/gprsec/log/conn.log") {
	$winconn2=MainWindow->new();
	$winconn2->title ("GPRS Easy Connect");
	if ($no_beep !=1) {
		$winconn2->bell;
	}


	$noauth_sz=$winconn2->Label(fg=>'red', text=>lancolas($cl[67]))->pack(); # nincs jogosultsg a pppd-hez (ekkor nem jn ltre a conn.log)

	$noauth_b=$winconn2->Button(text=>"Ok", command=>\sub {exit})->pack();

	$winconn2->OnDestroy(\sub {exit});
MainLoop ();
}
$readwin=MainWindow->new();
	$readwin->title (lancolas ($cl[20])); #Kapcsolds folyamatban...
$xfele=$xvhor/2;
$greadwin=$xfele-261;
$readwin->geometry("+$greadwin+0");
$disc_file="/usr/share/gprsec/log/re";
if (-e $disc_file) {
`rm $disc_file`;
	if ($bg_rec!=0) {
	$readwin->iconify;
	}
}

$kapcswin=$readwin->Frame(relief=>'sunken', bd=>2)->pack(side=>'top');

$aframe=$readwin->Frame()->pack();

$readwin->maxsize('523','138');
$readwin->minsize('523','138');

$k1=$kapcswin->Label()->pack();
$tux=$kapcswin->Label(-image=> $kapcswin->Photo(-file => "/usr/share/gprsec/images/wstux.xpm"),
	-border=> 0);
$tux->pack(side=>'left');
$earth=$kapcswin->Label(-image=> $kapcswin->Photo(-file => "/usr/share/gprsec/images/w1.gif"),
	-border=> 0);
$earth->pack(side=>'right');
$hat_on="off";

$downfr=$kapcswin->Frame()->pack(side=>'bottom');
$stat_b=$downfr->Button(text=>lancolas($cl[50]), command=>\&onoff)->pack(side=>'left'); #Statisztikai adatokat mutat/elrejt
$spec_button=$downfr->Button(text=>lancolas($cl[51]), command=>\&spec_stat)->pack(side=>'right'); #Specilis statisztika
$uzframe=$kapcswin->Frame()->pack(side=>'bottom');

$uzenet=$uzframe->Label(fg=>'red', width=>50, height=>5, fg=>'blue',textvariable=>\lancolas($cl[20]))->pack(); #A kapcsolds folyamatban...



# a figyle algoritmusok:
# a pppd echinak figyelse
$id = $kapcswin->repeat($idores,=> \&be);
# a kapcsoldsi llapot helyzetnek figyelse
$jd = $kapcswin->repeat(10,=> \&cont);

$kapcswin->OnDestroy(\&diskonnect);

canvas_cucc ();


#ha nincs meg statisztikai llomny,a kkor ltrehoz egy jat
if (!-e "/usr/share/gprsec/log/sp_stat") {
	$tempfilename=">/usr/share/gprsec/log/sp_stat";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	for ($x=1; $x<=288; $x++) {
	print FILE "$x\:\:\:\n";
	}
	close FILE;
}
# statisztikai llomnyok esetleges hibinak kijavtsa:
$egesz=`cat '/usr/share/gprsec/log/sp_stat'`;
@egall=split /\n/, $egesz;

foreach (@egall) {
	@act_line=split /\:/, $_;
	if ($act_line[3]>7) {
		$_="$act_line[0]:0:0:0";
	}
}
$tempfilename=">/usr/share/gprsec/log/sp_stat";
open (FILE, $tempfilename);
chmod 0666, $tempfilename;
foreach (@egall) {
	print FILE "$_\n";
}

MainLoop();

sub canvas_cucc {
# a statisztika canvas kialaktsa
		$hat=$aframe->Canvas(width=>523, height=>480)->pack(side=>'left');
		# a statisztika eleminek megjelentse
	# sszes forgalmazott adat:
		# letlttt byte
  		if (-e "/usr/share/gprsec/log/osszb_le") {
			$ob_l_v=`cat '/usr/share/gprsec/log/osszb_le'`;
		}
		$start_y=16;

		$regtimekezd_szov=$hat->Label(text=>lancolas($cl[84])); #kezdet ideje
		$hat->createWindow(10, $start_y+0, window=>$regtimekezd_szov, -anchor => 'w' ); # kezd. id?
		$regtimekezd_v=$hat->Label(); #kezdet ideje
		$hat->createWindow(343, $start_y+0, window=>$regtimekezd_v, -anchor => 'w' ); # kezd. id?

		$ob_l_szov=$hat->Label(text=>lancolas($cl[28]) ); #Az EasyConnal sszesen letlttt adatok:
		$hat->createWindow(10, $start_y+20, window=>$ob_l_szov, -anchor => 'w' );
		$ob_l=$hat->Label();
		$hat->createWindow(353, $start_y+20, window=>$ob_l, -anchor => 'w' );
		# feltlttt byte
		if (-e "/usr/share/gprsec/log/osszb_fel") {
			$ob_f_v=`cat '/usr/share/gprsec/log/osszb_fel'`;
		}
		$ob_f_szov=$hat->Label(text=>lancolas($cl[29])); #Az EasyConnal sszesen feltlttt adatok:
		$hat->createWindow(10, $start_y+40, window=>$ob_f_szov, -anchor => 'w' );

		$ob_f=$hat->Label();
		$hat->createWindow(353, $start_y+40, window=>$ob_f, -anchor => 'w' );


		$osszlefel_sz_sz=$hat->Label(text=>lancolas($cl[109])); #sszesen Forgalmazott adatmennyisg:
		$hat->createWindow(10, $start_y+60, window=>$osszlefel_sz_sz, -anchor => 'w' );
		$osszlefel_sz=$hat->Label(); #fe s le
		$hat->createWindow(353, $start_y+60, window=>$osszlefel_sz, -anchor => 'w' ); #fe s le
		
		$hetiforg_sz=$hat->Label(text=>lancolas($cl[110])); #Az elmlt ht nap foglama:
		$hat->createWindow(10, $start_y+80, window=>$hetiforg_sz, -anchor => 'w' );
		$hetiforg_v=$hat->Label();
		$hat->createWindow(353, $start_y+80, window=>$hetiforg_v, -anchor => 'w' );

		#hatrolvonal
		$hat->createLine(0, $start_y+95, 523, $start_y+95);
		# Forgalmazott adatmennyisg:
		$ad_fel_sz=$hat->Label(text=>lancolas ($cl[30])); #Forgalmazott adatmennyisg:
		$hat->createWindow(230, $start_y+110, window=>$ad_fel_sz, -anchor => 'center' );
			# bjtokban le
			$ad_le_b_sz=$hat->Label(text=>lancolas($cl[31])); #Bjtokban le:
			$hat->createWindow(10, $start_y+130, window=>$ad_le_b_sz, -anchor => 'w' );
			$ad_le_b=$hat->Label();
			$hat->createWindow(157, $start_y+130, window=>$ad_le_b, -anchor => 'w' );
			# bjtokban fel
			$ad_fel_b_sz=$hat->Label(text=>lancolas($cl[32])); #Bjtokban fel:
			$hat->createWindow(10, $start_y+150, window=>$ad_fel_b_sz, -anchor => 'w' );
			$ad_fel_b=$hat->Label();
			$hat->createWindow(157, $start_y+150, window=>$ad_fel_b, -anchor => 'w' );
			# csomagban le
			$ad_le_cs_sz=$hat->Label(text=>lancolas($cl[33])); #Csomag le:
			$hat->createWindow(270, $start_y+130, window=>$ad_le_cs_sz, -anchor => 'w' );
			$ad_le_cs=$hat->Label();
			$hat->createWindow(410, $start_y+130, window=>$ad_le_cs, -anchor => 'w' );
			# csomagban le
			$ad_fel_cs_sz=$hat->Label(text=>lancolas($cl[34])); #Csomag fel:
			$hat->createWindow(270, $start_y+150, window=>$ad_fel_cs_sz, -anchor => 'w' );
			$ad_fel_cs=$hat->Label();
			$hat->createWindow(410, $start_y+150, window=>$ad_fel_cs, -anchor => 'w' );
		#hatrolvonal
		$hat->createLine(0, $start_y+165, 523, $start_y+165);
		# az aktv kapcsolat tlagsebessge
		$akt_atl_sz=$hat->Label(text=>lancolas($cl[35])); #Az aktv kapcsolat adatforgalmi tlagsebessge:
		$hat->createWindow(10, $start_y+180, window=>$akt_atl_sz, -anchor => 'w' );
		$akt_atl_v=$hat->Label();
		$hat->createWindow(353, $start_y+180, window=>$akt_atl_v, -anchor => 'w' );
		#hatrolvonal
		$hat->createLine(0, $start_y+195, 523, $start_y+195);
		# kapcsolatid
			# mostani
			$kapcs_t_sz=$hat->Label(text=>lancolas ($cl[36])); #A kapcsolat idtartama:
			$hat->createWindow(10, $start_y+210, window=>$kapcs_t_sz, -anchor => 'w' );
			$kapcs_t_v=$hat->Label();
			$hat->createWindow(353, $start_y+210, window=>$kapcs_t_v, -anchor => 'w' );
			# sszes
			$kapcs_o_sz=$hat->Label(text=>lancolas ($cl[37])); #Az sszes kapcsolat idtartama:
			$hat->createWindow(10, $start_y+230, window=>$kapcs_o_sz, -anchor => 'w' );
			$kapcs_o_v=$hat->Label();
			$hat->createWindow(353, $start_y+230, window=>$kapcs_o_v, -anchor => 'w' );
			if (-e "/usr/share/gprsec/log/ossz_ido") {
				$kapcs_idok=`cat '/usr/share/gprsec/log/ossz_ido'`;
			}


		$stime=time;
		#hatrolvonal
		$hat->createLine(0, $start_y+245, 523, $start_y+245);
		# pillanatnyi sebessg
			# letltsi
			$ad_l_pill_sz=$hat->Label(text=>lancolas ($cl[38])); #Pillanatnyi letltsi sebessg:
			$hat->createWindow(10, $start_y+260, window=>$ad_l_pill_sz, -anchor => 'w' );
			$ad_l_pill=$hat->Label(fg=>'red');
			$hat->createWindow(353, $start_y+260, window=>$ad_l_pill, -anchor => 'w' );
			# feltltsi
			$ad_f_pill_sz=$hat->Label(text=>lancolas($cl[39])); #Pillanatnyi feltltsi sebessg:
			$hat->createWindow(10, $start_y+280, window=>$ad_f_pill_sz, -anchor => 'w' );
			$ad_f_pill=$hat->Label(fg=>'blue');
			$hat->createWindow(353, $start_y+280, window=>$ad_f_pill, -anchor => 'w' );


}

sub be {
$connlog=`cat /usr/share/gprsec/log/conn.log`;
$a=`tail -n 1 /usr/share/gprsec/log/conn.log`;


$_=$a;


$_=$a;
if (/ERROR/) {
	$id->cancel;
	$jd->cancel;
	beep ();
	red_col ();
	$uzenet->configure(textvariable=>\lancolas($cl[21])); #Kapcsoldsi hiba!
	red ();
	reconn ();
	return ();
}
$_=$a;
if (/is locked by pid/) {
	$id->cancel;
	$jd->cancel;
	@vege = split / /, $_;
	$hossz=@vege;
	$hossz--;
	chop ($vege[$hossz]);
	beep ();
	red_col ();
	$uzenet->configure(textvariable=>\lancolas ($cl[22]," $vege[$hossz] ")); #A***folyamat mr hasznlja,....
	red ();
	return ();
}
$_=$a;
if ($_ eq $a && /expect \(OK\)/) {
	$percent->after(100);
		$_=`tail -n 1 /usr/share/gprsec/log/conn.log`;
		if (/expect \(OK\)/) {
		red_col ();
		$id->cancel;
		$jd->cancel;
		$uzenet->configure(textvariable=>\lancolas($cl[23])); #A kapcsolatpts a vrakozsi ...
		beep ();
		red ();
		reconn ();
		return ();
		}
	}


$_=$a;
if (/\^\@/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(fg=>'red', textvariable=>\lancolas($cl[24])); # gy tnik, a telefont ...
		$cimke=100;
		red ();
		return ();
}
$_=$connlog;
if (m/No network protocols running/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(textvariable=>\lancolas($cl[40])); #A kapcsoldsi folymat megszakadt.\nA GPRS hlzat terhelt!
		red ();
		reconn ();
		return ();
}

$_=$connlog;
if (/LCP terminated by peer/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(textvariable=>\lancolas($cl[27])); #A kapcsoldsi folymat megszakadt.\nNincs vlasz a hlzattl.
		red ();
		reconn ();
		return ();
}
$_=$connlog;
if (/Connect script failed/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(textvariable=>\lancolas($cl[41])); #Konfigurcis hiba miatt a kapcsolds\nfolymata megszakadt.\nEllenrizd a belltsaidat!
		red ();
		return ();
}
$_=$connlog;
if (/Connection terminated./ && !/LCP terminated by peer/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(textvariable=>\lancolas($cl[42])); #Felhasznli megszakts.\nEsetleg a telefon lemerlt.\nVagy kicsszott az adatkbel.
		red ();
		return ();
	}
if ($a eq "\r" || $a eq "\n") {
	$kapcswin->after(1000);
		$ell=`tail -n 1 '/usr/share/gprsec/log/conn.log'`;
		if ($ell eq "\r" || $a eq "\n") {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(textvariable=>\lancolas ($cl[52])); #csatlakozsi folyamat\nkls?
		red ();
		reconn ();
		return ();
		}
}

$_=$a;
if (/Script \/etc\/ppp\/ip-up finished/) {
		$id->cancel;
		$jd->cancel;
		$readwin->title (lancolas ($cl[25])); #Kapcsolds sikeres!
		$cimke=100;
@mind=split /\n/,$connlog;
foreach (@mind) {
if (/local  IP address /) {
@local=split/local  IP address /, $_;
}
if (/remote IP address /) {
@remote=split/remote IP address /, $_;
}
if (/primary   DNS address /) {
@primary=split/primary   DNS address /, $_;
$d1=1;
}
if (/secondary DNS address /) {
@secondary=split/secondary DNS address /, $_;
$d2=1;
}
 }
if (!$d1 && !$d2) {
	$resolv_file=`cat '/etc/resolv.conf'`;
	@resolv=split/\n/, $resolv_file;
	foreach (@resolv) {
		if (/nameserver/) {
		push (@dns, $_);
		}
	}
	@primary=split/ /, $dns[0];
	@secondary=split/ /, $dns[1];
}
$uzenet->configure(fg=>'blue', textvariable=>\lancolas($cl[26], $local[1], $remote[1], $primary[1], $secondary[1])); #A kapcsoldsi folyamat sikeresen...
if ($co_pan==1){
$readwin->iconify;
}
# ciklus a kapcsolatmegszakads figyelshez
$watch=$kapcswin->repeat (3000,=>\&watch);
# ciklus generls az adatforgalmi adatok olvasshoz, kielemzshez, stb.
$dev=$aframe->repeat(1000, =>\&devs);



 }
$_=$a;
if (/Failed to open/ && /Permission denied/) {
		$id->cancel;
		$jd->cancel;
		beep ();
		red_col ();
		$uzenet->configure(textvariable=>\lancolas($cl[41])); #Konfigurcis hiba miatt a kapcsolds\nfolymata megszakadt.\nEllenrizd a belltsaidat!
		red ();
		return ();
}
} # hibakereses vege
sub cont {
# az llapotvonal megjelentshez szksges szmtsok
$sorok=`wc -c /usr/share/gprsec/log/conn.log`;
$sorok=~tr /[0-9]//cd;
$szazal=int(($sorok/$fullong)*100);
$_=$connlog;
$cimke=$_;
$cimke=$szazal." %, $tort";
$nev=int($cimke/10);
if ($nev>10) {$nev=10}
$tomb=$nev*10;
$akthoz=$cimke-$lastsz;
$akthoz=int($akthoz/1.74);
	for ($x=1; $x<=$akthoz; $x++) {
	$szaml++;
	if ($szaml<50) {
	$graf[$szaml]=$kapcswin->Label(-image=> $kapcswin->Photo(-file => "/usr/share/gprsec/images/tb.xpm"),
	-border=> 1, bg=>'black');
	$graf[$szaml]->pack(side=>'left');
	}
	}
$lastsz=$cimke;
}

sub watch {
$a=`cat '/usr/share/gprsec/log/conn.log'`;
$qwe++;
$_=$a;
if (/Serial link disconnected/ || /LCP terminated by peer/ || /Connection terminated/) {
	$readwin->title (lancolas($cl[43])); #A kapcsolat megszakadt!
	$watch->cancel;
	$id->cancel;
	$jd->cancel;
	$dev->cancel;
	if ($bg_rec!=0) {
		$readwin->iconify;
		} else {
		$readwin->raise;
		$readwin->deiconify;
		}
		$uzenet->configure(fg=>'red', textvariable=>\lancolas($cl[43]));
		red ();
		beep ();
		reconn ();
		return;
}
}

sub red_col {
$uzenet->configure(fg=>'red');
}
sub red {
# kapcsolatmegszakads esetn a taskbar vrsre vlt.
$lastsz_sz=$lastsz;
$lastsz_sz=~tr / %,//d;

for ($x=1; $x<=$lastsz_sz; $x++) {
		if ($graf[$x]) {$graf[$x]->destroy;

		$graf[$x]=$kapcswin->Label(-image=> $kapcswin->Photo(-file => "/usr/share/gprsec/images/ctb.xpm"),
		-border=> 1, bg=>'white');
		$graf[$x]->pack(side=>'left');
		}
}
}


sub diskonnect {

$veger=$kapcswin->Label(fg=>'red', width=>50, height=>5)->pack();
$pidin=`ps -C pppd`;
@ideig=split /\n/,$pidin;
if ($ideig[1]) {
		@elemek=split / /, $ideig[1];
		$pid_pppd=$elemek[1];
		`kill -s INT $pid_pppd`;
		}

$pidin=`ps -C chat`;
@ideig=split /\n/,$pidin;
if ($ideig[1]) {
		@elemek=split / /, $ideig[1];
		$pid_chat=$elemek[1];
		`kill -s KILL $pid_chat`;
		}
exit;
$veger->configure( text=> "-$pid_pppd-, -$pid_read2-, -$pid_chat");
}

sub devs {

($mpx, $percx, $orax, $napx, $honapx)=localtime;
$honapx++;
if ($havit_v && $havit_v<=$napx && $honapx>$honap || $honap+2<=$honapx) {
	# adatmenynisgek trlse
	foreach (qw/osszb_fel osszb_le/) {
		if (-e "/usr/share/gprsec/log/$_") {
			`rm '/usr/share/gprsec/log/$_'`;
		}
	}
	undef $ob_f_v;
	undef $ob_l_v;
	# a statisztikai adatok rgztsnek kezdete
	open (FILE, "</usr/share/gprsec/log/EasyConn.config");
	$sor=<FILE>;
	@temp=split /\:/, $sor;
	close FILE;
	($mp, $perc, $ora, $nap, $honap, $ev)=localtime();
	$honap++;
	$ev+=1900;
	$temp[13]="  $ev/$honap/$nap $ora;$perc";
	$temp[26]=$honap;
	$tempfilename=">/usr/share/gprsec/log/EasyConn.config";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	print FILE "$temp[0]:$temp[1]:$temp[2]:$temp[3]:$temp[4]:$temp[5]:$temp[6]:$temp[7]:$temp[8]:$temp[9]:$temp[10]:$temp[11]:$temp[12]:$temp[13]:$temp[14]:$temp[15]:$temp[16]:$temp[17]:$temp[18]:$temp[19]:$temp[20]:$temp[21]:$temp[22]:$temp[23]:$temp[24]:$temp[25]:$temp[26]\n";
	close FILE;
	read_conf ();
}

$last_bytes=$szamok[2];
$last_bytes_fel=$szamok[10];
$last_cs_le=$szamok[3];
$last_cs_fel=$szamok[11];
$info=`cat /proc/net/dev`;
@lines=split /\n/, $info;

foreach (@lines) {
	if (/ppp/) {
		$lines_darab=$_;
		$lines_darab=~s /\:/\:  /;
	}
}
@szamok=split / +/, $lines_darab;
# pillanatnyi letltsi sebessg meghat:
$ad_lb=(int((($szamok[2]-$last_bytes)/1024)*10))/10;

# pillanatnyi feltltsi sebessg meghat:
$ad_fb=(int((($szamok[10]-$last_bytes_fel)/1024)*10))/10;

# sszes letlttt byte-ok szmllsa
	$ad_le_b_v+=$szamok[2]-$last_bytes;
	$m_egy1=" byte";
	$oszb1=$ad_le_b_v;
	if ($ad_le_b_v>1024) {
		$oszb1=int(($ad_le_b_v/1024)*100)/100;
		$m_egy1=" KB";

	}
	$mb=1024*1024;
	if ($ad_le_b_v>$mb) {
		$oszb1=int(($ad_le_b_v/$mb)*1000)/1000;
		$m_egy1=" MB";
	}

# sszes feltlttt byte-ok szmllsa
	$ad_fel_b_v+=$szamok[10]-$last_bytes_fel;
	$m_egy2=" byte";
	$oszb2=$ad_fel_b_v;
	if ($ad_fel_b_v>1024) {
		$oszb2=int(($ad_fel_b_v/1024)*100)/100;
		$m_egy2=" KB";
	}
	$mb=1024*1024;
	if ($ad_fel_b_v>$mb) {
		$oszb2=int(($ad_fel_b_v/$mb)*1000)/1000;
		$m_egy2=" MB";
	}

# sszes csomag le
$ad_le_cs_v+=($szamok[3]-$last_cs_le);

# sszes csomag fel
$ad_fel_cs_v+=($szamok[11]-$last_cs_fel);

# EasyConnal letlttt bjtok sszesen
$ob_l_v+=$ad_le_b_v-$last_bytes;
	$m_egy3=" byte";
	$oszb3=$ob_l_v;
	if ($ob_l_v>1024) {
		$oszb3=int(($ob_l_v/1024)*100)/100;
		$m_egy3=" KB";
	}
	$mb=1024*1024;
	if ($ob_l_v>$mb) {
		$oszb3=int(($ob_l_v/$mb)*1000)/1000;
		$m_egy3=" MB";
	}

# EasyConnal feltlttt bjtok sszesen
$ob_f_v+=$ad_fel_b_v-$last_bytes_fel;
	$m_egy4=" byte";
	$oszb4=$ob_f_v;
	if ($ob_f_v>1024) {
		$oszb4=int(($ob_f_v/1024)*100)/100;
		$m_egy4=" KB";
	}
	$mb=1024*1024;
	if ($ob_f_v>$mb) {
		$oszb4=int(($ob_f_v/$mb)*100)/100;
		$m_egy4=" MB";
	}

# EasyConnal forgalmazott bjtok sszesen
$osszfl=$ob_l_v+$ob_f_v;
	$m_egy5=" byte";
	$oszb5=$osszfl;
	if ($osszfl>1024) {
		$oszb5=int(($osszfl/1024)*100)/100;
		$m_egy5=" KB";
	}
	$mb=1024*1024;
	if ($osszfl>$mb) {
		$oszb5=int(($osszfl/$mb)*100)/100;
		$m_egy5=" MB";
	}



# az aktv adatfolyam tlagos letltsi sebessge
if ($ad_lb!=0 && $ad_lb>0.1) { # a 0.1 szrs az adatletlts "beindulsa" miatt szksges
$seb_stat++;
$atl_seb_o+=$ad_lb;
$atl_seb=$atl_seb_o/$seb_stat;
$atl_seb=int($atl_seb*10)/10;

	$akt_atl_v->configure(text=>"$atl_seb KB/s");

}
# kapcsolat id
$mtime++;

$ora=int($mtime/3600);
$perc=int(($mtime-($ora*3600))/60);
$mperc=$mtime-($ora*3600)-($perc*60);

if ((length $mperc)==1) {$mperc="0".$mperc}
if ((length $perc)==1) {$perc="0".$perc}
if ((length $ora)==0) {$ora="00".$ora_v}
if ((length $ora)==1) {$ora="0".$ora}

# sszes id

$kapcs_idok++;

$time_o=int($kapcs_idok/3600);
$time_p=int(($kapcs_idok-($time_o*3600))/60);
$time_mp=$kapcs_idok-($time_o*3600)-($time_p*60);

if ((length $time_mp)==1) {$time_mp="0".$time_mp}
if ((length $time_p)==1) {$time_p="0".$time_p}
if ((length $time_o)==1) {$time_o="0".$time_o}
if ((length $time_o)==0) {$time_o="00".$time_o}

$tempfilename=">/usr/share/gprsec/log/ossz_ido";
open (FILE, $tempfilename);
chmod 0666, $tempfilename;
print FILE "$kapcs_idok";
close FILE;
$tempfilename=">/usr/share/gprsec/log/osszb_le";
open (FILE, $tempfilename);
chmod 0666, $tempfilename;
print FILE $ob_l_v;
close FILE;
$tempfilename=">/usr/share/gprsec/log/osszb_fel";
open (FILE, $tempfilename);
chmod 0666, $tempfilename;
print FILE $ob_f_v;
close FILE;

# az elmlt 7 nap adatforgalma:

$mainap=time;
$mainap=int($mainap/86400);
undef $all7day;

dbmopen (%NAP, "/usr/share/gprsec/log/7d", 0666);
$NAP{$mainap}+=$szamok[2]-$last_bytes+$szamok[10]-$last_bytes_fel;
foreach $key (keys %NAP) {
	if ($key<=$mainap-7) {
		delete $NAP{$key};
	}
}
foreach $key (keys %NAP) {
	$all7day+=$NAP{$key};
}
close %NAP;

# 7 nap forgalmnak prefixumai
	$m_egy6=" byte";
	$oszb6=$all7day;
	if ($all7day>1024) {
		$oszb6=int(($all7day/1024)*100)/100;
		$m_egy6=" KB";
	}
	$mb=1024*1024;
	if ($all7day>$mb) {
		$oszb6=int(($all7day/$mb)*100)/100;
		$m_egy6=" MB";
	}



#kirsok

	$ad_l_pill->configure(text=>"$ad_lb KB/s");
	$readwin->title ("$ad_lb KB/s ".lancolas($cl[25]));
	$ad_f_pill->configure(text=>"$ad_fb KB/s");
	$ad_le_b->configure(text=>"$oszb1 $m_egy1");
	$ad_fel_b->configure(text=>"$oszb2 $m_egy2");
	$ad_le_cs->configure(text=>"$ad_le_cs_v");
	$ad_fel_cs->configure(text=>"$ad_fel_cs_v");
	$ob_l->configure(text=>"$oszb3 $m_egy3");
	$ob_f->configure(text=>"$oszb4 $m_egy4");
	$kapcs_t_v->configure(text=>"$ora:$perc:$mperc");
	$kapcs_o_v->configure(text=>"$time_o:$time_p:$time_mp");
	$regtimekezd_v->configure(text=>$reg_time); #kezdet ideje

# limitek kzeledtnek figyelse
$havilimit_v90=(($havilimit_v*90)/100)*1024*1024*1024; # havi limit gigabjtban
if ($havilimit_v90<=$osszfl && $havilimit_v) {
	if ($hav_fenn==1) {
		$hav_fenn=0;
		$hat_on="off";
		onoff ();
		$readwin->focusForce;
		$readwin->raise();
		$readwin->deiconify;
	}
	if ($hav_vill==0) {
	$osszlefel_sz->configure(fg=>'red', text=>"$oszb5 $m_egy5");
	$osszlefel_sz_sz->configure(fg=>'red'); #sszesen Forgalmazott adatmennyisg:
		if (!$b1_1) {
		$b1_1 = $hat->Balloon(bg=>'yellow');
		$b1_1->attach($osszlefel_sz_sz,-msg => lancolas($cl[117]));
		}
	} else {
	$osszlefel_sz->configure(fg=>'blue', text=>"$oszb5 $m_egy5");
	$osszlefel_sz_sz->configure(fg=>'black'); #sszesen Forgalmazott adatmennyisg:
	}
	$hav_vill=abs($hav_vill-1);
}  else {
	$osszlefel_sz->configure(fg=>'blue', text=>"$oszb5 $m_egy5");
	$hav_fenn=1;
}


$hetilimit_v90=(($hetilimit_v*90)/100)*1024*1024; # havi limit megabjtban
if ($hetilimit_v90<=$all7day && $hetilimit_v) {
	if ($het_fenn==1) {
		$het_fenn=0;
		$hat_on="off";
		onoff ();
		$readwin->focusForce;
		$readwin->raise();
		$readwin->deiconify;
	}
	if ($het_vill==0) {
	$hetiforg_v->configure(fg=>'red', text=>"$oszb6 $m_egy6");
	$hetiforg_sz->configure(fg=>'red'); #heti forgalom
		if (!$b2_1) {
		$b2_1 = $hat->Balloon(bg=>'yellow');
		$b2_1->attach($hetiforg_sz,-msg => lancolas($cl[118]));
		}
	} else {
	$hetiforg_v->configure(fg=>'#0f6039', text=>"$oszb6 $m_egy6");
	$hetiforg_sz->configure(fg=>'black');
	}
	$het_vill=abs($het_vill-1);
}  else {
	$hetiforg_v->configure(fg=>'#0f6039', text=>"$oszb6 $m_egy6");
	$hetiforg_sz->configure(fg=>'black');
	$het_fenn=1;

}

# specilis statiszikai adatok mentse (ha a pill. seb>0.1, akkor mentse)
if ($ad_lb>0.1) {
	open (FILE, "</usr/share/gprsec/log/sp_stat");
	while ($sor=<FILE>) {
	push (@alap, $sor);
	}
	close FILE;
	($mp5, $perc5, $ora5)=localtime;
	$dikp5=$ora5*60+$perc5;
	$dik5=int($dikp5/5);

	foreach (@alap) {
		@sorelemek=split/\:/, $_;
		if ($sorelemek[0]==$dik5) {
			$sorelemek[1]++;
			$ujossz=($sorelemek[2]+$ad_lb);
			$ujatl=(int(($ujossz/$sorelemek[1])*10))/10;
			$_="$sorelemek[0]:$sorelemek[1]:$ujossz:$ujatl\n";
		}
	}
	$tempfilename=">/usr/share/gprsec/log/sp_stat";
	open (FILE, $tempfilename);
	chmod 0666, $tempfilename;
	foreach (@alap) {
	print FILE $_;
	}
	undef @alap;
	close FILE;
}
}




sub onoff {
	if ($hat_on eq "on") {
	$hat_on="off";
	$readwin->geometry('523x138');
	$readwin->maxsize('523','138');
	$readwin->minsize('523','138');
	} else {
	$readwin->geometry('523x495');
	$readwin->maxsize('523','455');
	$readwin->minsize('523','455');
	$hat_on="on";

	}
}

sub spec_stat {
if ($specwinn) {
	$specwinn->focusForce;
	$specwinn->raise();
	$specwinn->deiconify;
	return;
}
$specwinn=MainWindow->new();
$specwinn->OnDestroy(\sub {undef $specwinn});

	$specwinn->title (lancolas($cl[44])); #Specilis statisztikai bra (EasyConn)
$specwinn->maxsize('400','380');
$specwinn->minsize('400','380');
$grafframe=$specwinn->Frame()->pack();
$kommframe=$specwinn->Frame()->pack();


graf ();
$komm_fel=$kommframe->Frame()->pack(side=>'top');
$komm_le=$kommframe->Frame()->pack(side=>'bottom');
$nbutton1=$komm_fel->Button(text=>lancolas($cl[45]), command=>\&ad_ki)->pack(side=>'left'); #Adatok kiegsztse nlkl
$nbutton2=$komm_fel->Button(text=>lancolas($cl[46]), command=>\&ad_be)->pack(side=>'left'); #Adatok kiegsztsvel
$nbutton3=$komm_le->Button(text=>lancolas($cl[47]), command=>\&von)->pack(side=>'left'); #Vonaldiagramm
$nbutton4=$komm_le->Button(text=>lancolas($cl[48]), command=>\&osz)->pack(side=>'left'); #Oszlopdiagramm
$il=$jd = $grafframe->repeat(300000,=> \sub {$sback->destroy; undef @yok; undef @soroks; graf()});

MainLoop ();

sub ad_ki {
$sback->destroy;
undef $ki;
undef @yok;
undef @soroks;
graf ();
}
sub ad_be {
$sback->destroy;
$ki="yes";
undef @yok;
undef @soroks;
graf ();
}

sub von {
$sback->destroy;
undef $st;
undef @yok;
undef @soroks;
graf ();
}

sub osz {
$sback->destroy;
$st="osz";
undef @yok;
undef @soroks;
graf ();
}


sub graf {
# grafikus fellet
$sback=$grafframe->Canvas(width=>400, height=>320, bg=>gray)->pack();
$cim_sz=$sback->Label(bg=>'gray', text=>lancolas($cl[49])); # A pillanatnyi letltsi sebessgek 5...

$ycim=$sback->Label(bg=>'gray', text=>"KB/s");
$sback->createWindow(7, 150, window=>$ycim, anchor=>'nw');
$xcim=$sback->Label(bg=>'gray', text=>lancolas ($cl[53])); #ra
$sback->createWindow(200, 305, window=>$xcim, anchor=>'center');


open (FILE, "</usr/share/gprsec/log/sp_stat");
while ($sor=<FILE>) {
@temp=split/\:/, $sor;
push (@soroks, $temp[3]);
$nagyatl+=$temp[3];
	if ($temp[3]>0) {$spszam++}
}
$oldy=270-(30*$soroks[1]);
for ($i=1; $i<=288; $i++) {
	$xhely=60+$i;
	$yhely_k=270-(30*$soroks[$i]);
	push (@yok, $xhely);
	if ($yhely_k==270 && $ki eq "yes") {
		$yhely_k=$oldy;
	}
	push (@yok, $yhely_k);
	if ($st) {
		$sback->createLine($xhely, $yhely_k, $xhely, 270, -fill=>'red'); #oszlop
	}
	$oldy=$yhely_k;
}
if (!$st) {
	$sback->createLine(@yok, -fill=>'red', width=>1); #vonal
}
if ($spszam) { # ha mg nincs statisztikai llomnyban adat, akkor nullval akar osztani :-)
	$kbsatlag=(int(($nagyatl/$spszam)*10))/10;
} else {$kbsatlag=0}
$sback->createLine(55, 270-(30*$kbsatlag), 355, 270-(30*$kbsatlag), -fill=>'white', width=>2); #nagytlag
$nagyatl_cimke=$sback->Label(bg=>'gray', text=>"$kbsatlag");
$sback->createWindow(375, 270-(30*$kbsatlag), window=>$nagyatl_cimke, anchor=>'center');
undef $nagyatl;
undef $spszam;
# koordintarendszer
$sback->createWindow(200, 20, window=>$cim_sz, anchor=>'center');
$sback->createLine(60, 270, 348, 270);
$sback->createLine(60, 270, 60, 40, -arrow => 'last');
$sback->createLine(60, 267, 348, 267, -fill=>'#992f2f', -stipple => '@'.Tk->findINC('demos/images/grey.25'));


foreach (qw/1 2 3 4 5 6 7/){
	$yten[$_]=$sback->Label(bg=>'gray', text=>"$_");
	$ytav=270-($_*30);
	$sback->createWindow(50, $ytav, window=>$yten[$_], anchor=>'center');
	$sback->createLine(55, $ytav, 65, $ytav);
	$sback->createLine(65, $ytav, 348, $ytav, -stipple => '@'.Tk->findINC('demos/images/grey.25'));
}

$sz_03=$sback->Label(bg=>'gray', text=>"0.1");
$sback->createWindow(56, 267, window=>$sz_03, anchor=>'e');
for ($i=0; $i<=24; $i++) {
	$xten[$i]=$sback->Label(bg=>'gray', text=>"$i");
	$xtav=$i*12+60;
	$sback->createLine($xtav,265, $xtav, 275);
	if ($i/2==int($i/2)) {
	$xcim0=$sback->Label(bg=>'gray', text=>"$i");
	$sback->createWindow($xtav, 285, window=>$xcim0, anchor=>'center');
	}
	}
	}
}


sub lancolas {
undef $kirak;
undef $po;
@l_temp=split /\*\*\*/, $_[0]; # a vltoz(k) helye a *** jelek helyn van
	foreach (@l_temp) {
	$po++;
	$kirak.="$_$_[$po]";
	}
	if (!$kirak) {$kirak="(No translated yet!)"}
	return $kirak;
}

sub nyelvbeolv {
$cl[0]=" ";
open (FILE, "</usr/share/gprsec/languages/$def_nyelv");
	while ($sor=<FILE>) {
	chomp $sor;
	$sor=~s /\\n/\n/g;
	push (@cl, $sor);
	}
}

sub read_conf {
# az el?z? telcsi beolvassa+config beolvassa
open (FILE, "</usr/share/gprsec/log/EasyConn.config");
$sor=<FILE>;
close FILE;
@spl=split /\:/, $sor;
$last=$spl[0];
$kivp=$spl[1];
$co_pan=$spl[2];
$brow=$spl[3];
$br_on=$spl[4];
$autocsat=$spl[5];
$def_nyelv=$spl[6];
$idores=$spl[12];
$reg_time=$spl[13];
	$reg_time=~s /\;/\:/;
$no_beep=$spl[18];
$bg_rec=$spl[19];
$havit_v=$spl[23];
$havilimit_v=$spl[24];
$hetilimit_v=$spl[25];
$honap=$spl[26];
chomp ($honap);
}

sub reconn {
$tempfilename=">/usr/share/gprsec/log/disc";
open (FILE, $tempfilename);
chmod 0666, $tempfilename;
close FILE;
}

sub beep {
	if ($no_beep !=1) {
		$readwin->bell;
	}
}
